defaultpen(1);

size(2000, 2000);

int n = stdin;
int w = stdin;

// Constants
real spread = 0.15;
real yscale = 0.3;
real radius = 0.1;
real labelfontsize = 20;
pen labelpen = fontsize(labelfontsize);
int maxpoints = 100000;

if(n <= maxpoints){

// Everybody has score 0 at time 0
pair[][] scores = array(n, new pair[] {(0.0,0.0)});

real maxscore = 0;

int points = 0;
for(int t = 0; t < w; ++t){
	int k = stdin;
	for(int j = 0; j < k && points < maxpoints; ++j){
		++points;
		
		int p = stdin;
		real prevscore = scores[p-1][scores[p-1].length-1].y;
		scores[p-1].push((t, prevscore));
		scores[p-1].push((t+1, prevscore + 1));
		maxscore = max(maxscore,  prevscore + 1);
	}
	if(points == maxpoints){
		w = t+1;
		break;
	}
}

yscale *= w/(1+maxscore);

for(int p = 0; p < n; ++p){
	real lastscore = scores[p][scores[p].length-1].y;
	scores[p].push((w, lastscore));
}

if(w < 100){
	for(int t = 0; t <= w; ++t){
		draw((t, -.2) -- (t, yscale*maxscore+0.2), linewidth(1) + grey);
	}
}

// Draw all graphs
for(int p = 0; p < n; ++p){
	real offset = spread /n * p;
	for(int i = 0; i < scores[p].length-1; ++i){
		pair p1 = (scores[p][i].x, yscale*scores[p][i].y-offset);
		pair p2 = (scores[p][i+1].x, yscale*scores[p][i+1].y-offset);
		path pa = p1 -- p2;
		draw(pa , colorPen[p]);
	}
}

if(points == maxpoints){
	label(scale(4)*"Cropped!", (0, maxscore*yscale));
}

shipout(bbox(xmargin=5, white, Fill));
}
